*+
*+
*+    Source Module => C:\HARB\CONTRIB\HTMLLIB\EXAMPLES\FUNCLIST.PRG
*+
*+    Functions: Function MAIN()
*+               Procedure Redirect()
*+               Procedure funclist()
*+               Function Readlist()
*+               Procedure BlankPage()
*+               Function MainPage()
*+               Procedure Links()
*+
*+    Reformatted by Click! 2.03 on May-31-2001 at  8:08 pm
*+
*+

#include "website.ch"

Static scSession := ""
Static scCmd     := ""
Static scQuery   := ""
Static soIni

//

*+
*+
*+    Function MAIN()
*+
*+
*+
Function MAIN( cCmd, cRecno )           // --> CMD line params. passed by server

     Local oCgi
     Local aCmd
     Local cQuery

     Set Date BRITISH

     If cCmd == NIL
        cCmd := ""
     Endif

     If "%" $ cCmd
        cCmd := DecodeURL( cCmd )
        aCmd := listAsArray( cCmd, " " )
        cCmd := aCmd[ 1 ]
        If Len( aCmd ) > 1
           cRecno := aCmd[ 2 ]
        Endif
     Endif

     scCmd := cCmd

     If "POST" $ Upper( Getenv( "REQUEST_METHOD" ) )
        oCgi   := oCGI():New()
        cQuery := Upper( oCgi:query_String )                // just in case...
     Else
        oCgi   := oCGI():New()
        cQuery := Upper( Getenv( "QUERY_STRING" ) )
     Endif

     scQuery := cQuery

     soIni := oIni():New( "website.ini" )
     soIni:read()
     soIni:close()

     //
     //  simple redirection based on command line arguments.
     //  Each of the following routines produces stand alone HTML/CGI output
     //
     //

     If "LIST" $ cCmd
        funclist( ocgi, crecno )
     Elseif "REDIRECT" $ cCmd
        Redirect( oCgi, cRecno )
     Elseif "MAINPAGE" $ cCmd
        MainPage()
     Elseif "LINKS" $ cCmd
        Links()
     Elseif "NEWPAGE" $ cCmd
        NewPage()
     Else
        BlankPage()
     Endif

Return nil

*+
*+
*+    Procedure Redirect()
*+
*+    Called from ( funclist.prg )   1 - function main()
*+
*+
*+
Procedure Redirect( ocgi, crecno )

     Local oHtm
     Define CGI ;
             TITLE "Redirection" ;
             JAVACODE "location.href='" + crecno + "';" ;
             BGCOLOR "white" ;
             OF oHtm
     oHtm:CGIClose()
Return

*+
*+
*+    Procedure funclist()
*+
*+    Called from ( funclist.prg )   1 - function main()
*+
*+
*+
Procedure funclist( oCgi, crecno )

     Local oHtm
     Local x

     Local aList
     Local p     := Fcreate( 'pppp' )
     Fwrite( p, crecno )
     Fclose( p )
     If Valtype( crecno ) == "C"
        If At( "API", crecno ) > 0
           alist := readlist( 'api.txt' )
        Elseif At( "OBJ", crecno ) > 0
           alist := readlist( 'obj.txt' )
        Endif
     Else
        alist := readlist( 'funclist.txt' )
     Endif
     Define CGI TITLE 'Harbour function task list for File Api,Extend Api,Gt Api,Error Api' bgcolor "white" CHARSET "iso-8859-1" of oHtm
     SET FONT "" of ohtm
     Define TABLE BGCOLOR "#66ccff" border 0 WIDTH 600 CENTER of ohtm
     ohtm:qqout( "<TBODY>" )
     ohtm:newTableRow()
     Define CELL height 1 width 90 aling middle center of ohtm
     //Start font COLOR "#ffff80" OF ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org" ;
             IMAGE "../images/hrbbtn.gif" ;
             border 0 height 43 width 99 Target "_top" OF oHtm
     //End font of ohtm
     ohtm:EndTableCell()
     Define CELL HEIGHT 1 WIDTH 474 Top OF OHTM
     Define TABLE BORDER 2 BGCOLOR "#66ccff" ;
             COLORDARK "#66ccff" ;
             COLORLIGHT "#66ccff" ;
             BORDERCOLOR "#ffffff" of ohtm
     ohtm:qqout( "<TBODY>" )
     ohtm:newTableRow()
     Define CELL HEIGHT 1 WIDTH 95 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     //start font color "#000000" size 2 of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/" ;
             Text "Home" FONTCOLOR "#000000" SIZE 2 STYLE "TEXT-DECORATION: none" BOLD of ohtm
     ohtm:endtablecell()
     Define CELL width 71 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/download.htm" ;
             Text "Download" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:EndTableCell()
     Define CELL width 85 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/links.htm" ;
             Text "Links" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:EndTableCell()
     Define CELL width 84 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/mailinglist.htm" ;
             Text "Mailing List" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()
     Define CELL width 123 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?http://www.hagbard.demon.co.uk/harbour/harbour.html" ;
             Text "FAQ" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endtablecell()
     ohtm:EndTableRow()
     oHtm:NewTableRow()
     Define CELL width 84 height 15 ;
             COLORDARK "#808080" ;
             COLORLIGHT "#ffffff" ;
             nowrap ALING middle of ohtm

     Say "Function List" ;
             TYPE "<B>" Color "#000000" STYLE "text-decoration: none" size 2 OF OHTM
     ohtm:Endtablecell()
     Define CELL width 71 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/crew.htm" ;
             Text "Crew List" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     Define CELL width 85 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/art.htm" ;
             Text "Harbour Art" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     Define CELL width 84 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/3rdparty.htm" ;
             Text "3rd Party" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()
     Define CELL width 123 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/hbdoc" ;
             Text "Documentation" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     ohtm:endtablerow() 
     ohtm:qqout( "</TBODY>" ) 
     ohtm:endTable() 
     ohtm:EndTableRow() 
     ohtm:qqout( "</TBODY>" ) 
     ohtm:endtable()
     oHtm:FontFace  := nil
     oHtm:FontSize  := nil
     oHtm:Fontcolor := nil
     set font "" of ohtm
     ohtm:Paragraph()
     Say "Below is a list of all Harbour " + ;
             "functions in the RTL and their current state. This list is " + ;
             "updated as changes are made to the library. This list is based on " + ;
             "Clipper 5.2. The legend is as follows:" SIZE 2 OF OHTM
     ohtm:Paragraph( .F. )
     ohtm:Paragraph()
     Say "<strong>Ready</strong><br>" + ;
             "No more work needed on this function" size 2 of ohtm
     ohtm:Paragraph( .F. )
     ohtm:Paragraph()
     Say "<strong>Started</strong><br>" + ;
             "This function needs some work but will provide basic " + ;
             "functionality and can be used for testing." size 2 of ohtm
     ohtm:Paragraph( .F. )
     ohtm:Paragraph()
     Say "<strong>Not Started</strong><br>" + ;
             "This function has yet to be written" size 2 of ohtm
     ohtm:Paragraph( .F. )
     ohtm:setcenter( .t. )

     Define TABLE BGCOLOR CLR_WHITE border 1 width 500 CELLPADDING 2 CELLSPACING 1 CENTER of oHtm
     oHtm:newTableRow()
     Define CELL Color "#3000FF" WIDTH "50%" SIZE 2 FONTCOLOR "#ffff00" ROWSPAN 2 of oHtm
     oHtm:qqout( "<center><b>Function</b>" )
     oHtm:EndTableCell()
     Define CELL Color "#3000FF" WIDTH "50%" SIZE 2 FONTCOLOR "#ffff00" COLSPAN 3 of oHtm
     oHtm:qqout( "<center><b>Status</b>" )
     oHtm:EndTableCell()
     oHtm:EndTableRow()
     oHtm:newTableRow()
     Define CELL Color "#3000FF" WIDTH "16%" SIZE 2 FONTCOLOR "#ffff00" of oHtm
     oHtm:qqout( "<center><b>Ready</b>" ) 
     oHtm:EndTableCell()

     Define CELL Color "#3000FF" WIDTH "16%" SIZE 2 FONTCOLOR "#ffff00" of oHtm
     oHtm:qqout( "<center><b>Stated</b>" ) 
     oHtm:EndTableCell()

     Define CELL Color "#3000FF" WIDTH "16%" SIZE 2 FONTCOLOR "#ffff00" of oHtm
     oHtm:qqout( "<center><b>Not Stated</b>" ) 
     oHtm:EndTableCell() 
     oHtm:EndTableRow()
     For x := 1 To Len( alist )
        oHtm:NewTableRow()
        Define cell width "50%" size 2 of ohtm
        oHtm:qqout( alist[ x, 1 ] ) 
        oHtm:EndTableCell()
        If alist[ x, 2 ] == "R"
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( '<CENTER><IMG SRC="../images/purple-m.gif">' ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( '&nbsp' ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( '&nbsp' ) 
           oHtm:EndTableCell() 
           oHtm:EndTableRow()
        Elseif alist[ x, 2 ] == "S"
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( '&nbsp' ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( '<CENTER><IMG SRC="../images/purple-m.gif">' ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( "&nbsp" ) 
           oHtm:EndTableCell() 
           oHtm:EndTableRow()

        Elseif alist[ x, 2 ] == "N"
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( "&nbsp" ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( "&nbsp" ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( '<CENTER><IMG SRC="../images/purple-m.gif">' ) 
           ; oHtm:EndTableCell() 
           oHtm:EndTableRow()
        Else
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( "&nbsp" ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( "&nbsp" ) 
           oHtm:EndTableCell()
           Define cell width "16%" size 2 of ohtm
           oHtm:qqout( "&nbsp" ) 
           oHtm:EndTableCell() 
           oHtm:EndTableRow()
        Endif
     Next
     ohtm:endtable()
     ohtm:qout()
     ohtm:qout()
     ohtm:qout()
     If Valtype( crecno ) == "C"
        If At( "API", crecno ) > 0
           Link "funclist.exe?LIST&OBJ" Text "Harbour Object Function List" of ohtm
           Link "funclist.exe?LIST" Text "Harbour Function List" of ohtm
        Elseif At( "OBJ", crecno ) > 0
           Link "funclist.exe?LIST&API" Text "Harbour API Function List" of ohtm
           Link "funclist.exe?LIST" Text "Harbour Function List" of ohtm
        Endif
     Else
        Link "funclist.exe?LIST&API" Text "Harbour API Function List" of ohtm
        Link "funclist.exe?LIST&OBJ" Text "Harbour Object Function List" of ohtm
     Endif

     oHtm:WriteLN( "funclist.exe Create with " + Version() + " and HTMLLIB" )
     oHtm:cgiClose()

Return

*+
*+
*+    Function Readlist()
*+
*+    Called from ( funclist.prg )   3 - procedure funclist()
*+
*+
*+
Function Readlist( cfile )

     Local alist   := {}
     Local nPos
     Local cBuffer := ""
     Local cFunc   := ''
     Local cStat   := " "
     ft_fuse( cFile )
     Do While !ft_FEOF()
       cBuffer := Ltrim( Rtrim( Alltrim( FReadLn() ) ) )
       cFunc   := Substr( cBuffer, 1, At( ";", cbuffer ) - 1 )
       If Empty( cFunc )
          cFunc := Substr( cBuffer, At( ";", cbuffer ) )
          cStat := " "
       Endif

       cBuffer := Strtran( cBuffer, cfunc, "" )
       cBuffer := Strtran( cbuffer, Chr( 13 ), "" )
       cBuffer := Strtran( cbuffer, ";", "" )

       cStat := cbuffer
       Aadd( alist, { cFunc, cStat } )
       FT_FSKIP()
     Enddo
     FT_FUSE()
Return alist

//

*+
*+
*+    Procedure BlankPage()
*+
*+    Called from ( funclist.prg )   1 - function main()
*+
*+
*+
Procedure BlankPage( oCgi )

     //
     Local oHtm
     Local oldColor
     Local OldSize
     Local OldFont

     Define CGI ;
             BGIMAGE( COMMON_BGIMAGE ) ;
             BGCOLOR( COMMON_BGCOLOR ) ;
             TITLE "ACTION Error !!!" ;
             OF oHtm

     oHtm:SetTextColor( "black" )
     oHtm:Setcenter( .T. )

     oHtm:WriteLN( "" )
     oHtm:WriteLN( "ERROR !!!" )
     oHtm:WriteLN( "" )
     oHtm:WriteLN( "Please specify an appropriate action..." )

     oHtm:cgiClose()

Return

*+
*+
*+    Function MainPage()
*+
*+    Called from ( funclist.prg )   1 - function main()
*+
*+
*+
Function MainPage( oCgi )

     Local oHtm

     Define CGI TITLE "Harbour, a free software Clipper compatible compiler." bgcolor "white" CHARSET "iso-8859-1" of oHtm
     //set font  "" of ohtm
     oHtm:FontFace  := nil
     oHtm:FontSize  := nil
     oHtm:Fontcolor := nil

     Define TABLE BGCOLOR "#66ccff" border 0 height 155 WIDTH 600 CENTER of ohtm
     ohtm:qqout( "<TBODY>" )
     ohtm:newTableRow()
     Define CELL height 33 width 90 aling middle center of ohtm
     //set font "" color "#ffff80" of ohtm
     Link "http://sourceforge.net/projects/harbour-project/" ;
             IMAGE "../images/sflogo.png" ;
             border 0 Target "_top" OF oHtm
     //set font "" color "black" of ohtm
     oHtm:EndTableCell()
     Define CELL WIDTH 474 HEIGHT 151 ROWSPAN 2 Top of ohtm
     Define TABLE BGCOLOR "#66ccff" height 143 width 494 border 2 ;
             COLORDARK "#66ccff" borderColor "#ffffff" ;
             COLORLIGHT "#66ccff" of oHtm
     ohtm:qqout( "<TBODY>" )
     ohtm:newTableRow()
     Define CELL HEIGHT 17 WIDTH 95 ;
             COLORDARK "#808080" ;
             COLORLIGHT "#ffffff" ;
             nowrap ALING middle of ohtm
     //start font color "#000000" size 2 of ohtm
     Say "Home" ;
             TYPE "<B>" Color "#000000" STYLE "text-decoration: none" size 2 OF OHTM
     ohtm:endtablecell()
     Define CELL width 71 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/download.htm" ;
             Text "Download" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:EndTableCell()
     Define CELL width 85 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/links.htm" ;
             Text "Links" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:EndTableCell()
     Define CELL width 84 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/mailinglist.htm" ;
             Text "Mailing List" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()
     Define CELL width 123 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?http://www.hagbard.demon.co.uk/harbour/harbour.html" ;
             Text "FAQ" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endtablecell()
     ohtm:EndTableRow()
     oHtm:NewTableRow()
     Define CELL width 84 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/functions.htm" ;
             Text "Function List" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM

     ohtm:Endtablecell()
     Define CELL width 71 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/crew.htm" ;
             Text "Crew List" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     Define CELL width 85 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/art.htm" ;
             Text "Harbour Art" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     Define CELL width 84 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/3rdparty.htm" ;
             Text "3rd Party" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()
     Define CELL width 123 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/hbdoc" ;
             Text "Documentation" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()
     ohtm:endtablerow()
     ohtm:newTableRow()
     Define cell colorlight "#ffffff" aling middle colspan 5 Color "#ffffff" colordark "#ffffff" ;
             width 482 height 71 borderColor "#ffffff" of ohtm
     Image "../images/theharbourproject2.gif" height "49" width 332 of ohtm
     ohtm:endTableCell()
     ohtm:endtablerow()
     ohtm:newTableRow()
     Define cell colorlight "#ffffff" aling middle colspan "5" Color "#ffffff" colordark "#ffffff" ;
             width 482 height 25 borderColor "#ffffff" center of ohtm
     oHtm:qqOut( "<H3 align=center>" )
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/download.htm" ;
             Text "Download latest source code from CVS here" FONTcolor "#000000" BOLD OF OHTM
     oHtm:qqOut( "</H3>" )
     ohtm:endTableCell()
     ohtm:endtablerow()

     oHtm:qqOut( "</TBODY>" ) 
     ohtm:endtable()
     ohtm:endTableCell()
     ohtm:endtablerow()
     ohtm:newTableRow()
     Define cell Top width 90 height 114 of ohtm
     Define table bordercolor "#ffffff" height 129 colordark "#66ccff" width 100 bgcolor "#66ccff" colorlight "#66ccff" border 1 of ohtm
     oHtm:qqOut( "<TBODY>" )
     ohtm:newTableRow()
     Define cell colorlight "#808080" aling middle width "100%" height 15 colordark "#ffffff" of ohtm
     Link "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik" Text "In Portugues" Fontcolor "#ffffff" target "_top" STYLE "TEXT-DECORATION: none" size 2 BOLD of ohtm
     ohtm:endTableCell()
     ohtm:endtablerow()
     ohtm:newTableRow()
     Define cell colorlight "#808080" aling middle width "100%" height 15 colordark "#ffffff" of ohtm
     oHtm:qqout( "<P align=center>" )
     Link "funclist.exe?REDIRECT&http://www.geocities.com/SiliconValley/Board/5300/" Text "In Spanish" Fontcolor "#ffffff" target "_top" STYLE "TEXT-DECORATION: none" size 2 BOLD of ohtm
     oHtm:qqout( "</P>" )
     ohtm:endTableCell()
     ohtm:endtablerow()
     ohtm:newTableRow()
     Define cell colorlight "#808080" aling middle width "100%" height 15 colordark "#ffffff" of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour.pl.eu.org/" Text "In Polish" Fontcolor "#ffffff" target "_top" STYLE "TEXT-DECORATION: none" size 2 BOLD of ohtm
     ohtm:endTableCell()
     ohtm:endtablerow()
     ohtm:newTableRow()
     oldColor := oHtm:Fontcolor
     OldSize  := oHtm:FontSize
     OldFont  := oHtm:FontFace

     Define cell colorlight "#808080" aling middle width "100%" height 15 colordark "#ffffff" of ohtm
     Link "funclist.exe?REDIRECT&https://sourceforge.net/bugs/?group_id=681" Text "Report<BR>bugs here" Fontcolor "#000080" target "_top" BOLD of ohtm

     ohtm:endTableCell()
     ohtm:endtablerow()
     oHtm:qqOut( "</TBODY>" ) 
     ohtm:endtable()
     ohtm:endTableCell()
     ohtm:endtablerow()
     oHtm:qqOut( "</TBODY>" ) 
     ohtm:endtable()
     //    Set font "" /*color oldcolor size oldsize*/ of ohtm
     Define table border 0 height 22 width 600 bgcolor CLR_WHITE of ohtm
     oHtm:qqOut( "<TBODY>" )
     ohtm:newTableRow()
     Define cell height 18 width 600 of oHtm
     oHtm:qqout( "<P align=center><br>" )
     Image "../images/bannerhrblt.gif" height 82 width 444 border 0 of ohtm
     oHtm:qqout( "</P>" )
     ohtm:endTableCell()
     ohtm:endtablerow()
     oHtm:qqOut( "</TBODY>" ) 
     ohtm:endtable()
     Define table border 0 width 600 bgcolor CLR_WHITE of ohtm
     oHtm:qqOut( "<TBODY>" )
     ohtm:newTableRow()
     Define cell width "100%" of ohtm
     //ohtm:PutHeading( "Harbour, a free software Clipper compatible compiler! ", 3,.f.)
     oHtm:qqout( '<h3 align=center> Harbour, a free software Clipper compatible compiler!' )
     oHtm:qout( '</h3>' )
     Define table border 0 width "100%" bgcolor CLR_WHITE of ohtm
     oHtm:qqOut( "<TBODY>" )
     ohtm:newTableRow()
     Define cell width "56%" of ohtm
     ohtm:qqout( "<H2>" )
     //    Set font "" color oldcolor size oldsize of ohtm

     Say "Latest news:" type "<B><U>" Color "#ff0000" of ohtm
     ohtm:qqout( "</H2>" )
     ohtm:endTableCell()
     Define cell width "44%" of ohtm
     ohtm:qqout( "<H2 align=right>" )
     //set font "" color "#000000" of ohtm
     Link "http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/harbour-project/harbour/" ;
             Text "See latest Changelog" of ohtm
     ohtm:qqout( "</H2>" )
     ohtm:endTableCell()
     ohtm:endtablerow()
     oHtm:qqOut( "</TBODY>" ) 
     ohtm:endtable()
     ohtm:qqout( "<P>" )
     Image "../images/pijl.gif" height 11 width 17 alt "Arrow!" of ohtm
     Say "2001-03-06" Color "#408080" type "<EM><STRONG>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "More 0.36 files available for download on the" of oHtm
     Link "http://www.harbour-project.org/download.htm" Text " download page" of ohtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
     ohtm:qqout( "<P>" )
     Image "../images/pijl.gif" height 11 width 17 alt "Arrow!" of ohtm
     Say "2001-02-22" Color "#408080" type "<EM><STRONG>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Link "http://www.harbour-project.org/download.htm" Text "Release of Build #36" of oHtm
     oHtm:Listitem()
     Say "NTX read and write support " of oHtm
     oHtm:Listitem()
     Say "Support for Inline C code " of oHtm
     oHtm:Listitem()
     Say "Dot prompt and limited Harbour Interpreter " of oHtm
     oHtm:Listitem()
     Say "More support and fixes for ADS databases " of oHtm
     oHtm:Listitem()
     Say "Improved and fixed stack handling " of oHtm
     oHtm:Listitem()
     Say "Improved OOP " of oHtm
     oHtm:Listitem()
     Say "Better Class(y) and TopClass compatibility " of oHtm
     oHtm:Listitem()
     Say "MemoEdit() for 95% complete" of oHtm
     oHtm:Listitem()
     Say "More improved and enhanced TBrowse class " of oHtm
     oHtm:Listitem()
     Say "Lots of improvements on the Harbour Debugger " of oHtm
     oHtm:Listitem()
     Say "APPEND FROM &amp; COPY TO started " of oHtm
     oHtm:Listitem()
     Say "New hbMake utility" of oHtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
     ohtm:qqout( "<P>" )
     Image "../images/pijl.gif" height 11 width 17 alt "Arrow!" of ohtm
     Say "2000-11-25" Color "#408080" type "<EM><STRONG>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "Bison version 1.28b is on the " of oHtm
     Link "http://www.harbour-project.org/download.htm" Text "download page now. " of ohtm
     oHtm:Listitem()
     Link "http://www.harbour-project.org/mailinglist.htm" Text "Mailinglist" of oHtm
     Say " resources update." of oHtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
     ohtm:qqout( "<P>" )
     Image "../images/pijl.gif" height 11 width 17 alt "Arrow!" of ohtm
     Say "2000-09-19" Color "#408080" type "<EM><STRONG>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "Harbour Source Code in tar.gz format for Linux users available. See " of ohtm
     Link "http://www.harbour-project.org/download.htm" Text "Download Page" of oHtm
     oHtm:Listitem()
     Say 'OTC announces "Mediator" which is a Harbour RDD driver for Oracle,Microsoft SQL Server and Sybase Adaptive Server Anywhere. See ' of oHtm
     Link "http://www.harbour-project.org/3rdparty.htm" Text "3rd Party page" of ohtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
     ohtm:qqout( "<P>" )
     Image "../images/pijl.gif" height 11 width 17 alt "Arrow!" of ohtm
     Say "2000-08-24" Color "#408080" type "<EM><STRONG>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "Harbour binaries build with SimpLex (a Harbour specific lexical analyzer) are available now from the" of ohtm
     Link "http://www.harbour-project.org/download.htm" Text "Download Page." of ohtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
     ohtm:qqout( "<P>" )
     Image "../images/pijl.gif" height 11 width 17 alt "Arrow!" of ohtm
     Say "2000-08-18" Color "#408080" type "<EM><STRONG>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Link "http://www.harbour-project.org/download.htm" Text "Release of Build #35" of oHtm
     oHtm:Listitem()
     Say "Added HB_IDLE*() idle state handling functions." of oHtm
     oHtm:Listitem()
     Say "Watcom C++ fixes." of oHtm
     oHtm:Listitem()
     Say "SET RELATION support for RDDADS " of oHtm
     oHtm:Listitem()
     Say "New language modules: IT, DE, PL" of oHtm
     oHtm:Listitem()
     Say "Slang support enhanced" of oHtm
     oHtm:Listitem()
     Say "MemoEdit() / TEditor enhancements" of oHtm
     oHtm:Listitem()
     Say ".NTX support started (creation now works)" of oHtm
     oHtm:Listitem()
     Say "HBDOC .CHM output" of oHtm
     oHtm:Listitem()
     Say "Garbage collector added" of oHtm
     oHtm:Listitem()
     Say "Compiler -u, -m support, support for automatically compiled files for DO, SET FORMAT TO, etc., memory usage optimizations" of oHtm
     oHtm:Listitem()
     Say "Added HB_DISKSPACE(), __DBLIST(), __DBAPPEND() " of ohtm
     oHtm:Listitem()
     Say "Fixes: Line numbering, PP, macro compiler, RTL (Extend API, Item API,TRANSFORM(), DISKSPACE(), CURDIR(), __GET()), HBDOC,HBTEST (for Xbase++ and Linux), Documentation, Class engine" of oHtm
     oHtm:Listitem()
     Say "HBZLIB enhancements" of oHtm
     oHtm:Listitem()
     Say "MySQL database access contribution started" of oHtm
     oHtm:Listitem()
     Say "ADS RDD encryption/decryption functions added." of oHtm
     oHtm:Listitem()
     Say "New GTCGI driver" of oHtm
     oHtm:Listitem()
     Say "Improved command line parsing" of oHtm
     oHtm:Listitem()
     Say "Alternate Lexer (SimpLex), utilizes less memory, smaller Harbour.exe as well as smaller compiled applications (due to smaller macro compiler)." of oHtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()

     ohtm:endTableCell()
     ohtm:endtablerow()
     oHtm:qqOut( "</TBODY>" ) 
     ohtm:endtable()
     oHtm:cgiClose()
Return nil

*+
*+
*+    Procedure Links()
*+
*+    Called from ( funclist.prg )   1 - function main()
*+
*+
*+
Procedure Links( oCgi )

     Local oHtm
     Local x

     Define CGI TITLE 'Harbour function task list for File Api,Extend Api,Gt Api,Error Api' bgcolor "white" CHARSET "iso-8859-1" of oHtm
     SET FONT "" of ohtm
     oHtm:FontFace  := nil
     oHtm:FontSize  := nil
     oHtm:Fontcolor := nil

     Define TABLE BGCOLOR "#66ccff" border 0 WIDTH 600 CENTER of ohtm
     ohtm:newTableRow()
     Define CELL height 1 width 90 aling middle center of ohtm
     //Start font COLOR "#ffff80" OF ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org" ;
             IMAGE "../images/hrbbtn.gif" ;
             border 0 height 43 width 99 Target "_top" OF oHtm
     //End font of ohtm
     ohtm:EndTableCell()
     Define CELL HEIGHT 1 WIDTH 474 Top OF OHTM
     Define TABLE BORDER 2 BGCOLOR "#66ccff" ;
             COLORDARK "#66ccff" ;
             COLORLIGHT "#66ccff" ;
             BORDERCOLOR "#ffffff" of ohtm

     ohtm:newTableRow()
     Define CELL HEIGHT 1 WIDTH 95 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     //start font color "#000000" size 2 of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/" ;
             Text "Home" FONTCOLOR "#000000" SIZE 2 STYLE "TEXT-DECORATION: none" BOLD of ohtm
     ohtm:endtablecell()
     Define CELL width 71 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/download.htm" ;
             Text "Download" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:EndTableCell()
     Define CELL width 85 height 1 ;
             COLORDARK "#808080" ;
             COLORLIGHT "#ffffff" ;
             nowrap ALING middle of ohtm
     Say "Links List" ;
             TYPE "<B>" Color "#000000" STYLE "text-decoration: none" size 2 OF OHTM

     ohtm:EndTableCell()
     Define CELL width 84 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/mailinglist.htm" ;
             Text "Mailing List" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()
     Define CELL width 123 height 1 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?http://www.hagbard.demon.co.uk/harbour/harbour.html" ;
             Text "FAQ" FONTCOLOR "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endtablecell()
     ohtm:EndTableRow()
     oHtm:NewTableRow()
     Define CELL width 84 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/functions.htm" ;
             Text "Function List" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM

     ohtm:Endtablecell()
     Define CELL width 71 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/crew.htm" ;
             Text "Crew List" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     Define CELL width 85 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/art.htm" ;
             Text "Harbour Art" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     Define CELL width 84 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.harbour-project.org/3rdparty.htm" ;
             Text "3rd Party" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()
     Define CELL width 123 height 15 ;
             COLORDARK "#ffffff" ;
             COLORLIGHT "#808080" ;
             nowrap ALING middle of ohtm
     Link "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/hbdoc" ;
             Text "Documentation" FONTcolor "#000000" STYLE "text-decoration: none" size 2 BOLD OF OHTM
     ohtm:endTableCell()

     ohtm:endtablerow() 
     ohtm:endTable() 
     ohtm:endTableCell() 
     ohtm:EndTableRow() 
     ohtm:endtable()
     oHtm:FontFace  := nil
     oHtm:FontSize  := nil
     oHtm:Fontcolor := nil
     //    Set font ""  of ohtm

     Define table border 0 width 600 bgcolor CLR_WHITE of ohtm
     ohtm:newTableRow()
     Define cell width "100%" height 174 of ohtm
     ohtm:qqout( '<h3 align="center">' )
     Say "Links" type "<B><U>" of ohtm
     ohtm:qqout( '</h3>' + hb_osnewline() )
     oHtm:qqout( '<p>CCCPP, a Open Source Clipper compatible preprocessor written in C++<br>' )
     image "../images/pijl.gif" alt "Pijl naar Rechts.gif (50 bytes)" WIDTH 17 HEIGHT 11 of ohtm
     Link "http://www.nexus.hu/cccpp" target "_top" Text "http://www.nexus.hu/cccpp" of ohtm
     ohtm:qqout( "</p>" + hb_osnewline() )

     oHtm:qqout( '<p>Apple MPW tools<br>' )
     image "../images/pijl.gif" alt "Pijl naar Rechts.gif (50 bytes)" WIDTH 17 HEIGHT 11 of ohtm
     Link "http://developer.apple.com/tools/mpw-tools" target "_top" Text "http://developer.apple.com/tools/mpw-tools" of ohtm
     ohtm:qqout( "</p>" + hb_osnewline() )

     ohtm:endTableCell()
     ohtm:endtablerow() 
     ohtm:endTable()
     oHtm:cgiClose()
Return nil

Procedure NewPage( oCgi )

     Local oHtm
     Local x


         local cStyle:="hrb.css"

/**/
     Define CGI TITLE '[ Harbour Project ]' CHARSET "iso-8859-1" TEXTCOLOR "#111155" ;
     LINKCOLOR "#019FCD" ALINKCOLOR "#0EBCFE" VLINKCOLOR "#0176A3" ;
     ONLOAD "MM_preloadImages('../images/header_dwnld_over.gif','../images/header_funclst_over.gif','../images/header_maillst_over.gif','../images/header_faq_over.gif','../images/header_docum_over.gif','../images/header_links_over.gif','../images/header_3rdparty_over.gif','../images/header_art_over.gif','../images/header_crew_over.gif')" ;
     JAVASOURCE "hrb.js" STYLeSHEET cStyle of oHtm

//     SET FONT "" of ohtm
     oHtm:FontFace  := nil
     oHtm:FontSize  := nil
     oHtm:Fontcolor := nil
define table width "100%" border 0 cellpadding 0 CELLSPACING 0 bgcolor "white" of ohtm
ohtm:newtableRow()
define cell of ohtm
define table width "100%" height 155 border 0 cellpadding 0 CELLSPACING 0 bgcolor "white" of ohtm
ohtm:newtableRow()
define cell of ohtm
define table width "100%" border 0 cellpadding 0 CELLSPACING 0 bgcolor "white" of ohtm
ohtm:newtableRow()
define cell of ohtm
image "../images/header_boat1.gif" width  166  height  18  border 0 alt "" of ohtm
ohtm:endtablecell()
define cell  colspan 6 aling right size 2 of ohtm

Link "portugues.htm" Text "Portugues"  of ohtm
ohtm:qqout(" | ")
Link "spanish.htm" Text "Spanish" of ohtm
ohtm:qqout(" | ")                   
link "polish.htm" Text "Polish"  of ohtm
ohtm:qqout('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;')
     ohtm:endtablecell()
ohtm:endtablerow()
ohtm:newtableRow()
define cell of ohtm
image "../images/header_boat2.gif" width 166 height 32 border 0 of ohtm

ohtm:endtablecell()

define cell width "100%" of ohtm
image "../images/transpx.gif" width 10 border 0 of ohtm
ohtm:endtablecell()
define cell of ohtm
Link "download.htm" ONMOUSEOUT "MM_swapImgRestore()" ;
ONMOUSEOVER "MM_swapImage('download','','../images/header_dwnld_over.gif',1)" ;
image "../images/header_dwnld.gif" name "download" border 0  width 110 height 32 of ohtm
ohtm:endtablecell()
define cell of ohtm
Link "functionlist.htm" ONMOUSEOUT "MM_swapImgRestore()" ;
ONMOUSEOVER "MM_swapImage('functionlist','','../images/header_funclst_over.gif',1)" ;
image "../images/header_funclst.gif" name "functionlist" border 0  width 123 height 32 of ohtm
ohtm:endtablecell()

define cell of ohtm
Link "mailinglist.htm" ONMOUSEOUT "MM_swapImgRestore()" ;
ONMOUSEOVER "MM_swapImage('mailinglist','','../images/header_maillst_over.gif',1)" ;
image "../images/header_maillst.gif" name "mailinglist" border 0  width 107 height 32 of ohtm

ohtm:endtablecell()

define cell of ohtm
Link "faq.htm" ONMOUSEOUT "MM_swapImgRestore()" ;
ONMOUSEOVER "MM_swapImage('faq','','../images/header_faq_over.gif',1)" ;
image "../images/header_faq.gif" name "functionlist" border 0  width 85 height 32 of ohtm

ohtm:endtablecell()

define cell of ohtm
Image "../images/transpx.gif" width 18 height 32 border 0 of ohtm
ohtm:endtablecell()
ohtm:endtablerow();ohtm:endtable()

ohtm:endtablecell()
ohtm:endtablerow()
ohtm:newtablerow()
define cell of ohtm
define table border  0  width "100%" cellpadding  0  cellspacing  0  BGIMAGE "../images/header_horizon_1px.gif" bgcolor "white" of ohtm
ohtm:newtablerow()
define cell of ohtm
link "index.htm" image "../images/header_boat3.gif" width  166  height  105  border  0  alt "to the NewsPage..."  break of ohtm

image "../images/transpx.gif" width  18  height  18  border  0  of ohtm
ohtm:endtablecell()
define cell of ohtm
image "../images/header_harbour.gif"  width  189  height  105  border  0  break of ohtm
image "../images/transpx.gif" width  18  height  18  border  0 of ohtm
ohtm:endtablecell()
define cell aling center top width "100%" of ohtm
link "bugreport.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('bug','','../images/header_bug_over.gif',1)"  name "bug" border  0  image "../images/header_bug.gif" width  150  height  24 break of ohtm

Link "changelog.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('changelog','','../images/header_changelog_over.gif',1)"  name "changelog" border  0  image "../images/header_changelog.gif" width  150  height  23 break of ohtm

link "http://www.sourceforge.com/"  image "../images/sourceforge.gif" width  150 height  33  border  0  of ohtm
ohtm:endtablecell()
define cell of ohtm
link "documentation.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('docum','','../images/header_docum_over.gif',1)" name "docum" border  0  image "../images/header_docum.gif" width  123  height  24  break of ohtm

LINK "links.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('links','','../images/header_links_over.gif',1)" name "links" border  0  image "../images/header_links.gif" width  123  height  20  break of ohtm

LINK "thirdparty.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('thirdparty','','../images/header_3rdparty_over.gif',1)" name "thirdparty" border  0  image "../images/header_3rdparty.gif" width  123  height  20 break of ohtm

LINK "samples.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('samples','','../images/header_samples_over.gif',1)" name "samples" border  0  image "../images/header_samples.gif" width  123  height  20 break of ohtm

LINK "artwork.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('art','','../images/header_art_over.gif',1)" name "art" border  0  image "../images/header_art.gif" width  123  height  20 break of ohtm

LINK "thecrew.htm" onMouseOut "MM_swapImgRestore()" onMouseOver "MM_swapImage('crew','','../images/header_crew_over.gif',1)" name "crew" border  0  image "../images/header_crew.gif" width  123  height  19 break of ohtm
ohtm:endtablecell()

ohtm:endtablerow()
ohtm:endtable()

ohtm:endtablecell()
ohtm:endtablerow()
ohtm:endtable()
define table  border  0 width 100 cellspacing 0 cellpadding 0  bgcolor  "white" of  ohtm
ohtm:newtablerow()
define cell of ohtm
image "../images/whitepx.gif" width  9  height 9  border 0  of ohtm
define cell  width "75%" aling left top of ohtm
ohtm:qqout("<H1> Harbour News<BR>")
image "../images/bluepx.gif" width  450  height  2   border  0 of ohtm 
ohtm:qqout("</H1>")
     ohtm:qqout( "<P>" )
//     Link "" name "#2001-03-06" of ohtm
     Image "../images/pijlnaarrechts.gif" height 11 width 23 alt "Arrow!" of ohtm
     Say "2001-03-06"  font "sans-serif" Color "#cc1133" size 3 type "<U><I><B>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "More 0.36 files available for download on the" of oHtm
     Link "http://www.harbour-project.org/download.htm" Text " download page" of ohtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
LINK "#top" image "../images/redarrowup.gif" width  15  height 12  border  0  alt "to Top" break of ohtm
image "../images/redpx.gif"  width  450  height  1   border  0  of ohtm
     ohtm:qqout( "<P>" )
//     Link "" name "#2001-02-22" of ohtm
     Image "../images/pijlnaarrechts.gif" height 11 width 23 alt "Arrow!" of ohtm
     Say "2001-02-22"  font "sans-serif" Color "#cc1133" size 3 type "<U><I><B>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Link "http://www.harbour-project.org/download.htm" Text "Release of Build #36" of oHtm
     oHtm:Listitem()
     Say "NTX read and write support " of oHtm
     oHtm:Listitem()
     Say "Support for Inline C code " of oHtm
     oHtm:Listitem()
     Say "Dot prompt and limited Harbour Interpreter " of oHtm
     oHtm:Listitem()
     Say "More support and fixes for ADS databases " of oHtm
     oHtm:Listitem()
     Say "Improved and fixed stack handling " of oHtm
     oHtm:Listitem()
     Say "Improved OOP " of oHtm
     oHtm:Listitem()
     Say "Better Class(y) and TopClass compatibility " of oHtm
     oHtm:Listitem()
     Say "MemoEdit() for 95% complete" of oHtm
     oHtm:Listitem()
     Say "More improved and enhanced TBrowse class " of oHtm
     oHtm:Listitem()
     Say "Lots of improvements on the Harbour Debugger " of oHtm
     oHtm:Listitem()
     Say "APPEND FROM &amp; COPY TO started " of oHtm
     oHtm:Listitem()
     Say "New hbMake utility" of oHtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
LINK "#top" image "../images/redarrowup.gif" width  15  height 12  border  0  alt "to Top" break of ohtm
image "../images/redpx.gif"  width  450  height  1   border  0  of ohtm
     ohtm:qqout( "<P>" )
//     Link "" name "#2000-11-25" of ohtm
     Image "../images/pijlnaarrechts.gif" height 11 width 23 alt "Arrow!" of ohtm
     Say "2000-11-25"  font "sans-serif" Color "#cc1133" size 3 type "<U><I><B>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "Bison version 1.28b is on the " of oHtm
     Link "http://www.harbour-project.org/download.htm" Text "download page now. " of ohtm
     oHtm:Listitem()
     Link "http://www.harbour-project.org/mailinglist.htm" Text "Mailinglist" of oHtm
     Say " resources update." of oHtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
LINK "#top" image "../images/redarrowup.gif" width  15  height 12  border  0  alt "to Top" break of ohtm
image "../images/redpx.gif"  width  450  height  1   border  0  of ohtm
     ohtm:qqout( "<P>" )
//     Link "" name "#2000-09-19" of ohtm
     Image "../images/pijlnaarrechts.gif" height 11 width 23 alt "Arrow!" of ohtm
     Say "2000-09-19"  font "sans-serif" Color "#cc1133" size 3 type "<U><I><B>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "Harbour Source Code in tar.gz format for Linux users available. See " of ohtm
     Link "http://www.harbour-project.org/download.htm" Text "Download Page" of oHtm
     oHtm:Listitem()
     Say 'OTC announces "Mediator" which is a Harbour RDD driver for Oracle,Microsoft SQL Server and Sybase Adaptive Server Anywhere. See ' of oHtm
     Link "http://www.harbour-project.org/3rdparty.htm" Text "3rd Party page" of ohtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
LINK "#top" image "../images/redarrowup.gif" width  15  height 12  border  0  alt "to Top" break of ohtm
image "../images/redpx.gif"  width  450  height  1   border  0  of ohtm
     ohtm:qqout( "<P>" )
//     Link "" name "#2000-08-24" of ohtm
     Image "../images/pijlnaarrechts.gif" height 11 width 23 alt "Arrow!" of ohtm
     Say "2000-08-24"  font "sans-serif" Color "#cc1133" size 3 type "<U><I><B>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Say "Harbour binaries build with SimpLex (a Harbour specific lexical analyzer) are available now from the" of ohtm
     Link "http://www.harbour-project.org/download.htm" Text "Download Page." of ohtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
LINK "#top" image "../images/redarrowup.gif" width  15  height 12  border  0  alt "to Top" break of ohtm
image "../images/redpx.gif"  width  450  height  1   border  0  of ohtm
     ohtm:qqout( "<P>" )
//     Link "" name "#2000-08-18" of ohtm
     Image "../images/pijlnaarrechts.gif" height 11 width 23 alt "Arrow!" of ohtm
     Say "2000-08-18"  font "sans-serif" Color "#cc1133" size 3 type "<U><I><B>" of oHtm
     oHtm:NewList()
     oHtm:Listitem()
     Link "http://www.harbour-project.org/download.htm" Text "Release of Build #35" of oHtm
     oHtm:Listitem()
     Say "Added HB_IDLE*() idle state handling functions." of oHtm
     oHtm:Listitem()
     Say "Watcom C++ fixes." of oHtm
     oHtm:Listitem()
     Say "SET RELATION support for RDDADS " of oHtm
     oHtm:Listitem()
     Say "New language modules: IT, DE, PL" of oHtm
     oHtm:Listitem()
     Say "Slang support enhanced" of oHtm
     oHtm:Listitem()
     Say "MemoEdit() / TEditor enhancements" of oHtm
     oHtm:Listitem()
     Say ".NTX support started (creation now works)" of oHtm
     oHtm:Listitem()
     Say "HBDOC .CHM output" of oHtm
     oHtm:Listitem()
     Say "Garbage collector added" of oHtm
     oHtm:Listitem()
     Say "Compiler -u, -m support, support for automatically compiled files for DO, SET FORMAT TO, etc., memory usage optimizations" of oHtm
     oHtm:Listitem()
     Say "Added HB_DISKSPACE(), __DBLIST(), __DBAPPEND() " of ohtm
     oHtm:Listitem()
     Say "Fixes: Line numbering, PP, macro compiler, RTL (Extend API, Item API,TRANSFORM(), DISKSPACE(), CURDIR(), __GET()), HBDOC,HBTEST (for Xbase++ and Linux), Documentation, Class engine" of oHtm
     oHtm:Listitem()
     Say "HBZLIB enhancements" of oHtm
     oHtm:Listitem()
     Say "MySQL database access contribution started" of oHtm
     oHtm:Listitem()
     Say "ADS RDD encryption/decryption functions added." of oHtm
     oHtm:Listitem()
     Say "New GTCGI driver" of oHtm
     oHtm:Listitem()
     Say "Improved command line parsing" of oHtm
     oHtm:Listitem()
     Say "Alternate Lexer (SimpLex), utilizes less memory, smaller Harbour.exe as well as smaller compiled applications (due to smaller macro compiler)." of oHtm
     ohtm:qqout( '</LI>' )
     ohtm:endlist()
    ohtm:qout("<br>")
ohtm:endtablecell()
/*define cell  of ohtm
image "../images/transpx.gif" width  12  height  12  border  0 of ohtm
define cell width "100%" aling left top of ohtm
*/

ohtm:endtablecell()
ohtm:endtablerow()
ohtm:endtable()

ohtm:endtablecell()
ohtm:endtablerow()
ohtm:endtable()

     oHtm:cgiclose()
*+ EOF: FUNCLIST.PRG
